/* Button.js

{{IS_NOTE
	Purpose:
		
	Description:
		
	History:
		Jan 12, 2012 7:07:27 PM , Created by sam
}}IS_NOTE

Copyright (C) 2012 Potix Corporation. All Rights Reserved.

{{IS_RIGHT
}}IS_RIGHT
*/
(function () {

if (zk.ie6_ && !jq.IE6_ALPHAFIX) {
	jq.IE6_ALPHAFIX = '.png';
}
var AU = {au: true},
	AbstractButtonHandler = {
		doMouseDown_: function (evt) {
			var wgt = this._wgt;
			if (wgt) {
				var sheet = wgt.sheetCtrl;
				if (this._pp) {//fake spreadsheet focus
					wgt.focus(false);
				} else if (sheet) {
					// ZSS-744: spreadsheet still has focus in IE when mouse down, need to force it to stop editing.
					if (zk.ie) {
						sheet.dp.stopEditing('refocus');
					}
					sheet._doMousedown(evt);
				}
			}
		},
		doMouseUp_: function (evt) {
			var wgt = this._wgt;
			if (wgt) {
				var sheet = wgt.sheetCtrl;
				if (this._pp) {//fake spreadsheet focus
					wgt.focus(false);
				} else if (sheet) {
					sheet._doMouseup(evt);
				}
			}
		}
	},
	AbstractPopupHandler = {
		doMouseDown_: function (evt) {
			var wgt = this._wgt;
			if (wgt) {//fake focus
				wgt.focus(false);
			}
		},
		doMouseUp_: function (evt) {
			var wgt = this._wgt;
			if (wgt) {//fake focus
				wgt.focus(false);
			}
		}
	};

var urlCache = {};
function getScript(url, callback) {
	if (!urlCache[url]) {
		callback = callback || {};
		jq.ajax({
			 type: "GET",
			 url: url,
			 success: function (data) {
			 	urlCache[url] = data;
			 	callback(data);
			 },
			 dataType: "script",
			 cache: true
		 });
	} else if (callback) {
		callback(urlCache[url]);
	}
}

zss.FontSizeCombobox = zk.$extends(zul.inp.Combobox, {
	$init: function (props, wgt, builder) {
		this.$supers(zss.FontSizeCombobox, '$init', [props]);
		this._wgt = wgt;
		this._bd = builder;  //ZSS-1171
	},
	_$action: 'fontSize',
	$define: {
		/**
		 * Represent button's action at server side
		 */
		$action: null
	},
	//ZSS-1276
	$getAction: function () {
		return this._$aciton || this.$action;
	},
	setDisabled: function (actions) {
		var d = this.isDisabled();
		if (actions.$contains(this.$getAction())) { //ZSS-1276
			if (!d) {
				this.$supers(zss.FontSizeCombobox, 'setDisabled', [true]);
			}
		} else {
			if (d) {
				this.$supers(zss.FontSizeCombobox, 'setDisabled', [false]);
			}
		}
	},
	bind_: function () {
		this.$supers(zss.FontSizeCombobox, 'bind_', arguments);
		this.listen({onSelect: this});
		var wgt = this._wgt;
		if (wgt) {
			var sheet = wgt.sheetCtrl;
			if (sheet) {
				sheet.listen({onCellSelection: this.proxy(this._onCellSelection)});
			}
		}
	},
	unbind_: function () {
		var wgt = this._wgt;
		if (wgt) {
			var sheet = wgt.sheetCtrl;
			if (sheet) {
				sheet.unlisten({onCellSelection: this.proxy(this._onCellSelection)});
			}
		}
		this.unlisten({onSelect: this});
		this.$supers(zss.FontSizeCombobox, 'unbind_', arguments);
	},
	//ZSS-1171
//	preRow: null,
//	preCol: null,
//	preFontSize: null,
	_onCellSelection: function (evt) {
		//ZSS-1171: no show context menu, skip
		if (this._bd._skipNoShow()) {
			return;
		}

		var d = evt.data;
		//ZSS-1171: skip if select on the previous cell
		if (this.preRow == d.top && this.preCol == d.left) {
			return;
		}
		this.preRow = d.top;
		this.preCol = d.left;
		
		var	c = this._wgt.sheetCtrl.getCell(d.top, d.left);
		if (c) {
			var fontSize = c.getFontSize();
			//ZSS-1171: skip if same state
			if (fontSize == this.preFontSize) {
				return;
			}
			this.preFontSize = fontSize;
			
			this.setValue(fontSize);
		}
	},
	onSelect: function (evt) {
		var wgt = this._wgt,
			sheet = wgt.sheetCtrl,
			sel = evt.data.reference;
		if (sheet && sel) {
			var s = sheet.getLastSelection(),
				tRow = s.top,
				lCol = s.left,
				bRow = s.bottom,
				rCol = s.right,
				selType = sheet.selType ? sheet.selType : zss.SEL.CELL; //ZSS-717

			sheet.triggerSelection(tRow, lCol, bRow, rCol);
			wgt.fireToolbarAction('fontSize', 
				{size: sel.getLabel(), tRow: tRow, lCol: lCol, bRow: bRow, rCol: rCol, type: selType}); //ZSS-717
		}
	},
	_doBtnClick: function (evt) {
		var chd = this.firstChild;
		if (!chd) {
			var size = ['8', '9', '10', '11', '12', '14', '16', 
			            '18', '20', '22', '24', '26', '28', 
			            '36', '48', '72'];
			for (var i = 0, len = size.length; i < len; i++) {
				this.appendChild(new zul.inp.Comboitem({
					label: size[i],
					sclass: 'zsfontsize-' + size[i]
				}));
			}
		}
		this.$supers(zss.FontSizeCombobox, '_doBtnClick', arguments);
	},
	getSclass: function () {
		return 'zsfontsize';
	}
});
zk.copy(zss.FontSizeCombobox.prototype, AbstractPopupHandler);
	
zss.FontFamilyCombobox = zk.$extends(zul.inp.Combobox, {
	$init: function (props, wgt, builder) {
		this.$supers(zss.FontFamilyCombobox, '$init', [props]);
		this._wgt = wgt;
		this._bd = builder; //ZSS-1171
	},
	_$action: 'fontFamily',
	$define: {
		/**
		 * Represent button's action at server side
		 */
		$action: null
	},
	//ZSS-1276
	$getAction: function () {
		return this._$aciton || this.$action;
	},
	setDisabled: function (actions) {
		var d = this.isDisabled();
		if (actions.$contains(this.$getAction())) { // ZSS-1276
			if (!d) {
				this.$supers(zss.FontFamilyCombobox, 'setDisabled', [true]);
			}
		} else {
			if (d) {
				this.$supers(zss.FontFamilyCombobox, 'setDisabled', [false]);
			}
		}
	},
	bind_: function () {
		this.$supers(zss.FontFamilyCombobox, 'bind_', arguments);
		this.listen({onSelect: this});
		
		var wgt = this._wgt;
		if (wgt) {
			var sheet = wgt.sheetCtrl;
			if (sheet) {
				sheet.listen({onCellSelection: this.proxy(this._onCellSelection)});
			}
		}
	},
	unbind: function () {
		var wgt = this._wgt;
		if (wgt) {
			var sheet = wgt.sheetCtrl;
			if (sheet) {
				sheet.unlisten({onCellSelection: this.proxy(this._onCellSelection)});
			}
		}
		this.$supers(zss.FontFamilyCombobox, 'unbind', arguments);
	},
	//ZSS-1171
//	preRow: null,
//	preCol: null,
//	preFontName: null,
	_onCellSelection: function (evt) {
		//ZSS-1171: no show context menu, skip
		if (this._bd._skipNoShow()) {
			return;
		}
		
		var d = evt.data;
		//ZSS-1171: skip if select on same cell
		if (d.top == this.preRow && d.left == this.preCol) {
			return;
		}
		this.preRow = d.top;
		this.preCol = d.left;
		
		var	c = this._wgt.sheetCtrl.getCell(d.top, d.left);
		if (c) {
			var fontName = c.getFontName();
			//ZSS-1171: skip if same state
			if (this.preFontName == fontName) {
				return;
			}
			this.preFontName = fontName;
			
			this.setValue(fontName);
		}
	},
	unbind_: function () {
		this.unlisten({onSelect: this});
		this.$supers(zss.FontFamilyCombobox, 'unbind_', arguments);
	},
	onSelect: function (evt) {
		var wgt = this._wgt,
			sheet = wgt.sheetCtrl,
			sel = evt.data.reference;
		if (sheet && sel) {
			var s = sheet.getLastSelection(),
				tRow = s.top,
				lCol = s.left,
				bRow = s.bottom,
				rCol = s.right,
				selType = sheet.selType ? sheet.selType : zss.SEL.CELL; //ZSS-717

			sheet.triggerSelection(tRow, lCol, bRow, rCol);
			wgt.fireToolbarAction('fontFamily', 
				{name: sel.getLabel(), tRow: tRow, lCol: lCol, bRow: bRow, rCol: rCol, type: selType}); //ZSS-717
		}
	},
	_doBtnClick: function (evt) {
		var chd = this.firstChild;
		if (!chd) {
			var prefix = 'zsfontfamily',
				fonts = ['Calibri', 'Arial', 'Arial Black', 'Comic Sans MS', //ZSS-1072
			             'Courier New', 'Georgia', 'Impact', 
			             'Lucida Console', 'Lucida Sans Unicode',
			             'Palatino Linotype', 'Tahoma', 'Times New Roman',
			             'Trebuchet MS', 'Verdana', 'MS Sans Serif', 
			             'MS Serif'];
			for (var i = 0, len = fonts.length; i < len; i++) {
				var fontFamily = fonts[i],
					fs = fontFamily.toLowerCase().split(/\s+/),
					scls = prefix;
				
				for (var j = 0, fl = fs.length; j < fl; j++) {
					scls += ('-' + fs[j]);
				}
				this.appendChild(new zul.inp.Comboitem({
					label: fontFamily,
					sclass: scls
				}));
			}
		}
		this.$supers(zss.FontFamilyCombobox, '_doBtnClick', arguments);
	},
	getSclass: function () {
		return 'zsfontfamily';
	}
});
zk.copy(zss.FontFamilyCombobox.prototype, AbstractPopupHandler);
	
zss.ToolbarbuttonSeparator = zk.$extends(zul.wgt.Toolbarbutton, {
	$o: zk.$void,
	$define: {
		/**
		 * Represent button's action at server side
		 */
		$action: null
	},
	setDisabled: zk.$void,
	domTextStyleAttr_: function () {
		var u = zk.ajaxURI('/web/zss/img/sep.gif', {au: true});
		return zUtl.appendAttr("style", 'background:url(' + u + 
				') repeat-y scroll 0 0 transparent;height: 32px;width:2px;padding:0;');
	},
	getSclass: function () {
		return 'zstbtn-sep';
	}
});

zss.Toolbarbutton = zk.$extends(zul.wgt.Toolbarbutton, {
	$o: zk.$void,
	_actionIcon: null,
	//_defaultImage: null,
	/**
	 * The menupopup of the Toolbarbutton
	 */
	$init: function (props, wgt) {
		this.$supers(zss.Toolbarbutton, '$init', [props]);
		this._wgt = wgt;
	},
	$define: {
		/**
		 * Represent button's action at server side
		 */
		$action: null,
		clickDisabled: null
	},
	//ZSS-1276
	$getAction: function () {
		return this._$aciton || this.$action;
	},
	setDisabled: function (actions) {
		if (actions) {
			var disable = this.isDisabled();
			if (actions.$contains(this.$getAction())) { //ZSS-1276
				if (!disable){
					this.$supers(zss.Toolbarbutton, 'setDisabled', [true]);
				}
			} else if (disable) {//clear disabled
				this.$supers(zss.Toolbarbutton, 'setDisabled', [false]);
			}
			
		} else {
			this.$supers(zss.Toolbarbutton, 'setDisabled', arguments);
		}
	},
	setImage: function (v) {
		if (!this._defaultImage) {
			this._defaultImage = v;
		}
		this.$supers(zss.Toolbarbutton, 'setImage', arguments);
	},
//	//ZSS-1171
	preSel: false,
//	preMenuItem: null,
	/**
	 * @param boolean true set UI selected effect, set false to remove
	 * @param zss.Menuitem the menuitem that selected
	 */
	setSelectedEffect: function (seld, menuitem, updateIcon) {
		//ZSS-1171: skip if same state
		if (this.preSel == seld && this.preMenuItem == menuitem) {
			return;
		}
		this.preSel = seld;
		this.preMenuItem = menuitem;
		
		var pp = this.getPopup();
		var $n = jq(this.$n());
		var src = null;
		if (seld && pp && menuitem) {
			var src = menuitem.getImage();
			this._seldImage = src;
				
			if (src) {
				this.setImage(src);
			}
			if (updateIcon && menuitem.$action != this._actionIcon) {
				var real = jq(this.$n('real'));
				real.addClass('k-icon-' + menuitem.$action);
				real.removeClass('k-icon-' + this._actionIcon);
				this._actionIcon = menuitem.$action;
			}
		} else if (!menuitem) {
			this._seldImage = null;
			
			var src = this._defaultImage;
			if (src) {
				this.setImage(src);
			}
			$n.removeClass(this._getSclass() + '-seld');
			if (updateIcon && this._actionIcon != null) {
				jq(this.$n('real')).removeClass('k-icon-' + this._actionIcon);
				this._actionIcon = null;
			}
		}
		
		if (seld) {
			$n.addClass(this._getSclass() + '-seld');	
		} else {
			$n.removeClass(this._getSclass() + '-seld');
		}
	},
	bind_: function () {
		this.$supers(zss.Toolbarbutton, 'bind_', arguments);
		var cave = this.$n('cave');
		if (cave && !this._calWidth) { //contains menupopup, expand button width
			var disd = this.isClickDisabled(),
				seld = this._seldImage,
				scls = this._getSclass(),
				$n = jq(this.$n()),
				cnt = cave.parentNode,
				$cv = jq(cave),
				cw = $cv.width() + $cv.zk.sumStyles("lr", jq.paddings),
				w = $n.width() + $n.zk.sumStyles("lr", jq.paddings) + $n.zk.sumStyles("lr", jq.borders) + cw;
			if (w <= 49)//min size
				w = 49;
			this.setWidth(w + 'px');
			this._calWidth = true;//ZSS-216
			if (disd) {
				jq(cnt).addClass(scls + '-clk-disd');
			}
			if (seld) {
				$n.addClass(scls + '-seld');
			}
			jq(this.$n('real')).addClass('k-icon-' + this.$getAction());
		} else {
			jq(this.$n('cnt')).addClass('k-icon-' + this.$getAction());
		}
	},
	doClick_: function (evt) {
		var	cv = this.$n('cave'),
			taget = evt.domTarget;
		if(!this.isDisabled() && cv && jq.isAncestor(cv, taget)) {
			var pp = this._smartFellow(this.getPopup());
			if (pp) {
				pp.open(this, null, 'after_start');	
			}
		} else {
			if (this.isFireOnClick_(evt)) {
				this.fire('onClick');
			}
		}
		//controls fire onClick event, not invoke this.$supers('doClick_')
	},
	isFireOnClick_: function (evt) {
		return !this.isClickDisabled() && !this.isDisabled();
	},
	doMouseOver_: function (evt) {
		var	cv = this.$n('cave'),
			taget = evt.domTarget;
		if (!this.isDisabled() && cv) {
			if (jq.isAncestor(cv, taget)) {
				jq(cv).addClass(this._getSclass() + '-cave-over');
			}	
		}
		this.$supers(zss.Toolbarbutton, 'doMouseOver_', arguments);
	},
	doMouseOut_: function (evt) {
		var cv = this.$n('cave');
		if (cv) {
			jq(cv).removeClass(this._getSclass() + '-cave-over');
		}
		this.$supers(zss.Toolbarbutton, 'doMouseOut_', arguments);
	},
	domContent_: function () {
		var cnt = this.$supers(zss.Toolbarbutton, 'domContent_', arguments);
		if (this.getPopup()) {
			var uid = this.uuid,
				scls = this._getSclass();
			return '<div id="' + uid + '-real" class="' + scls + '-real">' + 
				cnt + '</div><div id="' + uid + '-cave" class="' + 
				scls +'-cave"><div class="' + scls +'-arrow"></div></div>';
		} else {
			return cnt;
		}
	},
	_getSclass: function () {
		return 'zstbtn';
	},
	getSclass: function () {
        var result = 'zstbtn-' + this.$getAction() + ' ' + this._getSclass();
        if (this.getPopup()) {
            result += ' zstbtn-w-pp';
        }
        return result; //ZSS-1276
//		return 'zstbtn-' + this.$getAction() + ' ' + this._getSclass(); //ZSS-1276
	}
}, {
	_rmActive: function (wgt) {
		var n = wgt.$n(),
			cv = wgt.$n('cave');
		if (cv) {
			jq(cv).removeClass(wgt._getSclass() + '-cave-over');
		}
		jq(n)
		.removeClass(wgt._getSclass() + '-over')
		.removeClass(wgt.getZclass() + '-over');
	}
});
zk.copy(zss.Toolbarbutton.prototype, AbstractButtonHandler);

zss.CheckableToolbarButton = zk.$extends(zul.wgt.Toolbarbutton, {
	$init: function (props, wgt) {
		this.$supers(zss.CheckableToolbarButton, '$init', [props]);
		this.setWidth('48px');
		this._wgt = wgt;
	},
	$define: {
		/**
		 * Represent button's action at server side
		 */
		$action: null,
		/** Returns whether it is checked.
		 * <p>Default: false.
		 * @return boolean
		 */
		/** Sets whether it is checked.
		 * @param boolean checked
		 */
		checked: function (v) {
			var n = this.$n('real');
			if (n) {
				v? jq(n).addClass('zschktbtn-check-checked') : jq(n).removeClass('zschktbtn-check-checked');
//				n.style.backgroundImage = 'url(' + this.getCheckImage() + ')';
			}
		}
	},
	//ZSS-1276
	$getAction: function () {
		return this._$aciton || this.$action;
	},
	setDisabled: function (actions) {
		var d = this.isDisabled();
		if (actions.$contains(this.$getAction())) { //ZSS-1276
			if (!d)
				this.$supers(zss.CheckableToolbarButton, 'setDisabled', [true]);
		} else if (d) {//clear disabled
			this.$supers(zss.CheckableToolbarButton, 'setDisabled', [false]);
		}
	},
	getCheckImage: function () {
		return zk.ajaxURI('/web/zss/img/' + ((this.isChecked() ? 'ui-check-box' : 'ui-check-box-uncheck')) + (zk.ie6_ ? '.gif' : '.png'), {au: true});
	},
	domContent_: function () {
		return '<div id="' + this.uuid + '-real" class="' + this.getSclass() + '-check' + ' k-icon-' + this.$getAction() + (this.isChecked() ? ' zschktbtn-check-checked' : '') + '"></div>' + this.$supers(zul.wgt.Toolbarbutton, 'domContent_', arguments);
//		return '<div id="' + this.uuid + '-real" class="' + this.getSclass() + '-check" style="background: url(' +
//			this.getCheckImage() +') no-repeat transparent;"></div>' + this.$supers(zul.wgt.Toolbarbutton, 'domContent_', arguments);
	},
	getSclass: function () {
		return 'zschktbtn-' + this.$getAction() + ' zschktbtn'; //ZSS-1276
	}
});
zk.copy(zss.CheckableToolbarButton.prototype, AbstractButtonHandler);

zss.ProtectSheetCheckbutton = zk.$extends(zss.CheckableToolbarButton, {
	_$action: 'protectSheet',
	bind_: function () {
		var sheet = this._wgt.sheetCtrl;
		if (sheet) {
			sheet.listen({'onProtectSheet': this.proxy(this.onProtectSheet)});
		}
		this.$supers(zss.ProtectSheetCheckbutton, 'bind_', arguments);
	},
	onProtectSheet: function (evt) {
		this.setChecked(evt.data.protect);
	}
});

zss.DisplayGridlinesCheckbutton = zk.$extends(zss.CheckableToolbarButton, {
	_$action: 'gridlines',
	bind_: function () {
		var sheet = this._wgt.sheetCtrl;
		if (sheet) {
			sheet.listen({'onDisplayGridlines': this.proxy(this.onDisplayGridlines)});
		}
		this.$supers(zss.DisplayGridlinesCheckbutton, 'bind_', arguments);
	},
	onDisplayGridlines: function (evt) {
		this.setChecked(evt.data.show);
	}
});


if (zk.feature.pe) {
	zk.load('zkex.inp', null, function () {

		zss.Colorbox = zk.$extends(zkex.inp.Colorbox, {
			bind_: function () {
				this.$supers(zss.Colorbox, 'bind_', arguments);
				jq(this.$n('pp')).addClass('zscolorpopup');
			},
		});

		// customized color popup for spreadsheet
		zss.ColorPopup = zk.$extends(zss.Colorbox, {
				_visible: false,
				_ref: null,
				$init: function (ref) {
					this.$supers(zss.ColorPopup, '$init', []);
					this._ref = ref;
				},
				adjustPosition_: function() {
					// adjust popup position to ref. widget
					if(this._ref && this._ref.$n) {
						zk(this.$n('pp')).position(this._ref.$n(), this._getPosition());
					}
				},
				bind_: function () {
					this.$supers(zss.ColorPopup, 'bind_', arguments);
				},
				open: function() {
					this.openPopup();
					this.adjustPosition_();
				},
				openPalette: function() {
					this.$supers(zss.ColorPopup, 'openPalette', arguments);
					this.adjustPosition_();
				},
				openPicker: function() {
					this.$supers(zss.ColorPopup, 'openPicker', arguments);
					this.adjustPosition_();
				},
				shallStackup_: function() {
					return false; // disable stack up
				},
				_syncShadow: function(target) {
					// disable shadow
				},
				_hideShadow: function(target) {
					// disable shadow
				}
			}
		);
		
		zss.ColorbuttonEx = zk.$extends(zss.Toolbarbutton, {
			_color: '#000000', /*default color*/
			$init: function (props, wgt, popupHolder) {
				this.$supers(zss.ColorbuttonEx, '$init', [props]);
				this._wgt = wgt;
				this._colorPopup = new zss.ColorPopup(this);
				this.setPopup(this._colorPopup);
				if(popupHolder) {
					popupHolder.appendChild(this._colorPopup);
				}
			},
			$define: {
				/** Sets the image URI.
				 * @param String image the URI of the image
				 */
				/** Returns the image URI.
				 * <p>Default: null.
				 * @return String
				 */
				image: function (v) {
					var n = this.getImageNode();
					if (n) n.src = v || '';
				},
				/**
				 * Sets the color
				 * @param color in #RRGGBB format (hexdecimal).
				 */
				/**
				 * Returns the color
				 * @return string
				 */
				color: function (hex) {
					var c = this.$n('color');
					if (c)
						c.style.backgroundColor = hex;
				}
			},
			bind_: function () {
				this.$supers(zss.ColorbuttonEx, 'bind_', arguments);

				if(this._colorPopup) {
					this._colorPopup.listen({onChange: this.proxy(this.onChange)});
				}
			},
			unbind_: function () {
				if(this._colorPopup) {
					this._colorPopup.unlisten({onChange: this.proxy(this.onChange)});
				}
				
				this.$supers(zss.ColorbuttonEx, 'unbind_', arguments);
			},
			doKeyDown_: zk.$void,
			doKeyUp_: zk.$void,
			doKeyPress_: zk.$void,
			onChange: function (evt) { //invoke from Color Palette, not from event
				var hex = evt.data.color;
				this.setColor(hex);
				this.fire('onClick');
				var wgt = this._wgt;
				if (wgt) {
					wgt.focus(false);
				}
			},
			domContent_: function () {
				var uuid = this.uuid;
				var cnt = this.$supers(zss.ColorbuttonEx, 'domContent_', arguments);

				var out = new Array();
				out.push(cnt);
				out.push('<div id="' + uuid + '-color" class="zstbtn-color" style="background:' 
					+ this.getColor() + ';"></div>');
				
				return out.join('');
			},
			shallStackup_: function () {
				return false;
			}
		});
	})
}
//ZSS-463, define CE & PE ColorPicker at the same time on purpose
if(true){//ZK CE version
	zss.Colorbutton = zk.$extends(zss.Toolbarbutton, {
		_open: false,
		_color: '#000000', /*default color*/
		$init: function (props, wgt) {
			this.$supers(zss.Colorbutton, '$init', [props]);
			this._wgt = wgt;
		},
		$define: {
			/** Sets the image URI.
			 * @param String image the URI of the image
			 */
			/** Returns the image URI.
			 * <p>Default: null.
			 * @return String
			 */
			image: function (v) {
				var n = this.getImageNode();
				if (n) n.src = v || '';
			},
			/**
			 * Sets the color
			 * @param color in #RRGGBB format (hexdecimal).
			 */
			/**
			 * Returns the color
			 * @return string
			 */
			color: function (hex) {
				var c = this.$n('color');
				if (c)
					c.style.backgroundColor = hex;
			}
		},
		bind_: function () {
			this.$supers(zss.Colorbutton, 'bind_', arguments);
			zWatch.listen({onFloatUp: this});
		},
		unbind_: function () {
			zWatch.unlisten({onFloatUp: this});
			this.$supers(zss.Colorbutton, 'unbind_', arguments);
		},
		onFloatUp: function (ctl) {
			if (!zUtl.isAncestor(this, ctl.origin))
				this.closePopup();
		},
		doMouseOver_: _onCell = function (evt) {
			var target = evt.domTarget,
				scls = this.getSclass();
			if (jq(target).parents('.' + scls + '-pp')[0]) {
				jq(target).parents('.' + scls + '-cell')
				[evt.name == 'onMouseOver' ? 'addClass' : 'removeClass'](scls + '-cell-over');
			} else
				jq(this.$n())[evt.name == 'onMouseOver' ? 'addClass' : 'removeClass'](scls + '-over');
		},
		doMouseOut_: _onCell,
		doClick_: function (evt) {
			var t = evt.domTarget,
				p = this.$n('pp'),
				$t = jq(evt.domTarget),
				scls = this.getSclass();

			if (jq.isAncestor(p, t)) {
				if ($t.attr('class').indexOf(scls + '-cell-cnt') >= 0) {
					var hex = $t.children('i').text();
					
					this.setColor(hex);
					this.fire('onClick');
					this.closePopup();
					$t.parent().removeClass(scls + '-cell-over');	
				}
			} else {
				if (this._open) {
					this.closePopup();
				} else {
					this.openPopup();
				}
			}
		},
		openPopup: function () {
			this._open = true;
			var node = this.$n(),
				pp = this.$n("pp");

			pp.style.position = "absolute";
			pp.style.overflow = "auto";
			pp.style.display = "block";
			pp.style.zIndex = "88000";

			jq(pp).zk.makeVParent();
			zk(pp).position(node, this._getPosition());
		},
		_getPosition: function () {
			var parent = this.parent;
			if (!parent) return;
			if (parent.$instanceof(zul.wgt.Toolbar))
				return 'vertical' == parent.getOrient() ? 'end_before' : 'after_start';
			return 'after_start';
		},
		closePopup: function () {
			this._open = false;
			var node = this.$n(),
				pp = this.$n("pp");
			jq(pp).zk.undoVParent();
		},
		domContent_: function () {
			var uid = this.uuid,
				cnt = this.$supers(zss.Colorbutton, 'domContent_', arguments),
				cols = zss.colorPalette.color,
				width = zss.colorPalette.width,
				height = zss.colorPalette.height,
				colSize = cols.length,
				scls = this.getSclass(),
				color = this.getColor();
			cnt = cnt + '<div id="' + uid + '-color" class="' + this.getSclass() + 
				'-color" style="background:' + this.getColor() + 
				';"></div><div id="' + uid + '-pp" style="display:none;width:'+width+'px;height:'+height+'px;" class="' + scls + '-pp">';
				
			for (var i = 0; i < colSize; i++) {
				cnt += '<div class="' + scls + '-cell"><div style="background: ' + cols[i] + 
					';" class="' + scls + '-cell-cnt"><i style="display: none">' + cols[i] + '</i></div></div>';
			}	
			cnt += '</div>';//Note. use Colorbox's "z-colorbtn-pp"
			return cnt;
		}
	});
}


zss.Menu = zk.$extends(zul.menu.Menu, {
	setDisabled: function (actions) {
		var pp = this.menupopup;
		if (pp && pp.setDisabled) {
			pp.setDisabled(actions);
		}
	},
	getSclass: function () {
		return 'zsmenu-' + this._sclass;
	}
});

zss.Menuitem = zk.$extends(zul.menu.Menuitem, {
	$init: function (props, wgt) {
		this.$supers(zss.Menuitem, '$init', [props]);
		this._wgt = wgt;
	},
	$define: {
		/**
		 * Represent button's action at server side
		 */
		$action: null
	},
	//ZSS-1276
	$getAction: function () {
		return this._$aciton || this.$action;
	},
	setDisabled: function (actions) {
		if (jq.isArray(actions)) {
			var d = this.isDisabled();
			if (actions.$contains(this.$getAction())) { //ZSS-1276
				if (!d)
					this.$supers(zss.Menuitem, 'setDisabled', [true]);
			} else if (d) {//clear disabled
				this.$supers(zss.Menuitem, 'setDisabled', [false]);
			}	
		} else {
			this.$supers(zss.Menuitem, 'setDisabled', arguments);
		}
	},
	bind_: function () {
		this.$supers(zss.Menuitem, 'bind_', arguments);
		jq(this.$n('a')).addClass('k-icon-' + this.$getAction());
	},
	domContent_: function () {
		var label = '<span class="' + this.$s('text') + '">'
					+ (zUtl.encodeXML(this.getLabel())) + '</span>',
			icon = '<i class="' + this.$s('icon') + ' z-icon-check"></i>',
			img = this.getImage(),
			iconSclass = this.domIcon_();

		if (img)
			img = '<img src="' + img + '" class="' + this.$s('image') + '" align="absmiddle" />'
				+ (iconSclass ? ' ' + iconSclass : '');
		else {
			if (iconSclass) {
				img = iconSclass;
			} else {
				img = '<img ' + (this.isTopmost() ? 'style="display:none"' : '')
					+ ' src="data:image/png;base64,R0lGODlhAQABAIAAAAAAAAAAACH5BAEAAAAALAAAAAABAAEAAAICRAEAOw==" class="' + this.$s('image') + '" align="absmiddle" />';
			}
		}
//		return img + (this.isAutocheck() || this.isCheckmark() ? icon : '') + label;
		return img + label;
	},
	getSclass: function () {
		return 'zsmenuitem-' + this.$getAction(); //ZSS-1276
	}
});
zk.copy(zss.Menuitem.prototype, AbstractPopupHandler);

zss.StateMenuitem = zk.$extends(zss.Menuitem, {
	$init: function (props, wgt) {
		this.$supers(zss.StateMenuitem, '$init', [props]);
		this.updateState = props.updateState;
		this._wgt = wgt;
	},
	updateState: null
});

if (zk.feature.pe) {
	zss.ColorMenuEx = zk.$extends(zss.Menu, {
		bind_: function () {
			this.$supers(zss.ColorMenuEx, 'bind_', arguments);
			jq(this.$n('cnt-pp')).addClass('zscolorpopup');
			this.listen({'onChange': this});
		},
		unbind_: function () {
			this.unlisten({'onChange': this});
			this.$supers(zss.ColorMenuEx, 'unbind_', arguments);
		},
		getColor: function () {
			return this.color;
		},
		onChange: function (evt) {
			this.color = evt.data.color;
		},
		getSclass: function () {
			return 'zscolormenu';
		}
	});
}

zss.ColorMenu = zk.$extends(zss.Menu, {
	_open: false,
	_color: null,
	$define: {
		content: _zkf = function (content) {
			if (!content || content.length == 0) return;
			
			var c = this.$n('img');
			if (c)
				c.style.backgroundColor = content;
			
			if (!this._contentHandler) {
				this._contentHandler = new zss.ColorMenuContentHandler(this, content);
			} else
				this._contentHandler.setContent(content);
		},
		color: _zkf
	},
	bind_: function () {
		this.$supers(zss.ColorMenu, 'bind_', arguments);
		var c = this.$n('img');//can't find img becuase of doesn't has this.desktop
		if (c)
			c.style.backgroundColor = this._color;
		
	},
	unbind_: function () {
		
		this.$supers(zss.ColorMenu, 'unbind_', arguments);
	},
	getSclass: function () {
		return 'zscolormenu';
	},
	getColor: function(){
		return this._color;
	}
});
zk.copy(zss.ColorMenu.prototype, AbstractPopupHandler);

zss.ColorMenuContentHandler = zk.$extends(zk.Widget, {
	$init: function(wgt, content) {
		this._wgt = wgt;
		this._content = content;
	 },
	 setContent: function (content) {
	 	if (this._content != content || !this._pp) {
			this._content = content;
			this._wgt.rerender();	
		}
	 },
	 redraw: function (out) {	 
		var wgt = this._wgt,
			uid = wgt.uuid,
			cols = zss.colorPalette.color,
			width = zss.colorPalette.width,
			height = zss.colorPalette.height,
			colSize = cols.length,
			scls = wgt.getSclass(),
			color = this._content;
		var cnt = '<div id="' + uid + '-cnt-pp" style="display:none;width:'+width+'px;height:'+height+'px;" class="' + scls + '-cnt-pp">';
			
		for (var i = 0; i < colSize; i++) {
			cnt += '<div class="' + scls + '-cell"><div style="background: ' + cols[i] + 
				';" class="' + scls + '-cell-cnt"><i style="display: none">' + cols[i] + '</i></div></div>';
		}	
		cnt += '</div>';//Note. use Colorbox's "z-colorbtn-pp"
		
		out.push(cnt);
		 
	 },
	 bind: function () {
	 	var wgt = this._wgt;
	 	if (!wgt.menupopup) {
			wgt.domListen_(wgt.$n(), 'onClick', 'onShow');
			zWatch.listen({onFloatUp: wgt, onHide: wgt});
		}
		
	 	this._pp = jq('#' + wgt.uuid + '-' + 'cnt-pp')[0];
	 	wgt.domListen_(this._pp, 'onClick', this.proxy(this._onPaletteClick));
	 },
	 unbind: function () {
	 	var wgt = this._wgt;
	 	if (!wgt.menupopup) {
			if (this._shadow) {
				this._shadow.destroy();
				this._shadow = null;
			}
			wgt.domUnlisten_(wgt.$n(), 'onClick', 'onShow');
			zWatch.unlisten({onFloatUp: wgt, onHide: wgt});
		}
	 	
	 	wgt.domUnlisten_(this._pp, 'onClick', this.proxy(this._onPaletteClick));
	 	
		this._pp = null;
	 },
	 isOpen: function () {
		 var pp = this._pp;
		 return (pp && zk(pp).isVisible());
	 },
	 onShow: function () {
	 	var wgt = this._wgt,
			pp = this._pp;
		if (!pp) return;
			
		pp.style.position = "absolute";
		pp.style.overflow = "auto";
		pp.style.display = "block";
		pp.style.zIndex = "88000";
			
		jq(pp).zk.makeVParent();
		zWatch.fireDown("onVParent", this);
			zk(pp).position(wgt.$n(), this.getPosition());
		this.syncShadow();
	 },
	 onHide: function () {
		var pp = this._pp;
		if (!pp || !zk(pp).isVisible()) return;
			pp.style.display = "none";
		jq(pp).zk.undoVParent();
		zWatch.fireDown("onVParent", this);
		this.hideShadow();
	 },
	 onFloatUp: function (ctl) {
		if (!zUtl.isAncestor(this._wgt, ctl.origin))
			this.onHide();
	 },
	 syncShadow: function () {
	 	if (!this._shadow)
			this._shadow = new zk.eff.Shadow(this._wgt.$n("cnt-pp"), {stackup:(zk.useStackup === undefined ? zk.ie6_: zk.useStackup)});
		this._shadow.sync();
	 },
	 hideShadow: function () {
	 	this._shadow.hide();
	 },
	 destroy: function () {
	 	this._wgt.rerender();
	 },
	 getPosition: function () {
	 	var wgt = this._wgt;
		if (wgt.isTopmost()) {
			var bar = wgt.getMenubar();
			if (bar)
				return 'vertical' == bar.getOrient() ? 'end_before' : 'after_start';
		}
		return 'end_before';
	},
	closePalette: function (close) {
	 	var pp = this._pp;
		if (!pp || !zk(pp).isVisible()) return;

		pp.style.display = "none";
		if (close)
			zWatch.fire('onFloatUp', null);
	},
	_onPaletteClick : function(evt){
		var t = evt.domTarget,
			wgt = this._wgt,
			p = this._pp,
			$t = jq(evt.domTarget),
			scls = wgt.getSclass();

		if (jq.isAncestor(p, t)) {
			if ($t.attr('class').indexOf(scls + '-cell-cnt') >= 0) {
				var hex = $t.children('i').text();
				this.closePalette(true);
				this._wgt.setColor(hex);
				evt.stop();
			}
		}
	}
});

zss.Menupopup = zk.$extends(zul.menu.Menupopup, {
	$init: function (wgt) {
		this.$supers(zss.Menupopup, '$init', []);
		this._wgt = wgt;
		this.z$rod = false; //ZSS-658 turn off ZK EE ROD to avoid only rendering a div
	},
	setDisabled: function (actions) {
		var chd = this.firstChild;
		for (;chd; chd = chd.nextSibling) {
			if (!chd.setDisabled) {//Menuseparator
				continue;
			}
			
			chd.setDisabled(actions);
		}
	},
	open: function () {
		this.$supers(zss.Menupopup, 'open', arguments);
		this.$n().style.top = jq.px(parseInt(this.$n().style.top) - 5);
		var wgt = this._wgt;
		if (wgt) {//fake focus
			wgt.focus(false);
		}
	},
	onFloatUp: function (ctl) {
		// ZSS-654: there are dual popup menu, so they will trigger each other's onFloatUp() cause them both be disappeared
		if (!this.isVisible()) {
			return;
		}
		
		if(this._wgt && this.isOpen() && zUtl.isAncestor(ctl.origin, this)) {
			return;
		}
		
		this.$supers(zss.Menupopup, 'onFloatUp', arguments);
	},
	zsync: function () {
		// skip shadow
	},
	getSclass: function () {
    	return 'zsmenupopup';
	}
}, {
	_rmActive: function (wgt) {
		if (wgt.parent.$instanceof(zul.menu.Menu)) {
			wgt.parent.$class._rmActive(wgt.parent);
		} else if (wgt.parent.$instanceof(zss.Toolbarbutton)) {
			wgt.parent.$class._rmActive(wgt.parent);
		}
	}
});

// same as zss.Menupopup except refresh item whether shown or hidden when open
zss.StateMenupopup = zk.$extends(zss.Menupopup, {
	updateItemState: function(info) {
		var child = this.firstChild;
		for(;child; child = child.nextSibling) {
			if(child.updateState)
				child.updateState.call(child, info);
		}
	}
});
	// same as newActionMenuitem except creating zss.StateMenuitem
	function newActionStateMenuitem(wgt, action, image, updateStateFunc) {
		return new zss.StateMenuitem({
			$action: action,
			image: image ? zk.ajaxURI(image, {au: true}) : null,
			label: msgzss.action[action],
			onClick: function () {
				var sheet = wgt.sheetCtrl;
				if (sheet) {
					var s = sheet.getLastSelection(),
						tRow = s.top,
						lCol = s.left,
						bRow = s.bottom,
						rCol = s.right,
						selType = sheet.selType ? sheet.selType : zss.SEL.CELL; //ZSS-717
					sheet.triggerSelection(tRow, lCol, bRow, rCol);
					wgt.fireToolbarAction(action, {tRow: tRow, lCol: lCol, bRow: bRow, rCol: rCol, type: selType}); //ZSS-717
				}
			},
			updateState: updateStateFunc
		},wgt);
	}

	function newActionMenuitem(wgt, action, image, icon) {
		return new zss.Menuitem({
			$action: action,
			image: image ? zk.ajaxURI(image, {au: true}) : null,
			label: msgzss.action[action],
			onClick: function () {
				var sheet = wgt.sheetCtrl;
				if (sheet) {
					var s = sheet.getLastSelection(),
						tRow = s.top,
						lCol = s.left,
						bRow = s.bottom,
						rCol = s.right,
						selType = sheet.selType ? sheet.selType : zss.SEL.CELL; //ZSS-717
					sheet.triggerSelection(tRow, lCol, bRow, rCol);
					wgt.fireToolbarAction(action, {tRow: tRow, lCol: lCol, bRow: bRow, rCol: rCol, type: selType}); //ZSS-717
				}
			}
		},wgt);
	}
	
	function newRichTextEditActionMenuitem(wgt, action) {
		return new zss.Menuitem({
			$action: action,
			label: msgzss.action[action],
			onClick: function () {
				var sheet = wgt.sheetCtrl;
				if (sheet) {
					var s = sheet.getLastSelection(),
						tRow = s.top,
						lCol = s.left,
						bRow = s.bottom,
						rCol = s.right,
						selType = sheet.selType ? sheet.selType : zss.SEL.CELL; //ZSS-717
					sheet.triggerSelection(tRow, lCol, bRow, rCol);
					wgt.fireToolbarAction(action, {tRow: tRow, lCol: lCol, bRow: bRow, rCol: rCol, type: selType}); //ZSS-717
				}
			}
		}, wgt);
	}
	
	function newBorderActionMenuitem(wgt, colorWidget, action, image) {
		return new zss.Menuitem({
			$action: action,
			image: image ? zk.ajaxURI(image, {au: true}) : null,
			label: msgzss.action[action],
			onClick: function () {
				var sheet = wgt.sheetCtrl;
				if (sheet) {
					var s = sheet.getLastSelection(),
						color = colorWidget ? colorWidget.getColor() : '',
						selType = sheet.selType ? sheet.selType : zss.SEL.CELL; //ZSS-717

					wgt.fireToolbarAction(action, {color: color, tRow: s.top, lCol: s.left, bRow: s.bottom, rCol: s.right, type: selType}); //ZSS-717
				}
			}
		},wgt);
	}
	
	function newBorderColorMenu(spreadsheet){
		return (!!zss.ColorMenuEx && spreadsheet.getColorPickerExUsed()) ? new zss.ColorMenuEx({
			$action: 'borderColor',
			label: msgzss.action.borderColor,
			content: '#color=#000000'
		},spreadsheet) : new zss.ColorMenu({
			$action: 'borderColor',
			label: msgzss.action.borderColor,
			color: '#000000'
		},spreadsheet);
	}

	function triggerByMenupopup (menupopup, widget, testActiveElement) {
		return menupopup && menupopup.isOpen() && (zUtl.isAncestor(menupopup, widget) ||
				// ZSS-654: IE11 and IE9 would focus tag in menupopup
				(testActiveElement && jq.isAncestor(menupopup.$n(), document.activeElement)));
	}
	
zss.StylePanel = zk.$extends(zul.wgt.Popup, {
	$init: function (wgt) {
		this.$supers(zss.StylePanel, '$init', []);
		if (zk.ie6_)
			this.setWidth('186px');
		this._wgt = wgt;
		//ZSS-630 in zk 7 and IE 9
		this.zssPartner = true;
		var	self = this,
			tb = new zul.wgt.Toolbar({sclass: 'zsstylepanel-toolbar'}),
			builder = new zss.ButtonBuilder(wgt, this),
			btns = builder.addAll(['fontFamily', 'fontSize', 'fontBold', 'fontItalic']).build(),
			fontFamily = btns[0],
			fontSize = btns[1],
			b;
		
		var styleContainer = new zul.wgt.Div({sclass: 'zsstylepanel-upper'});
		this.appendChild(styleContainer);
		
		wgt.listen({onAuxAction: this.proxy(this._closeStylePanel)});
		fontFamily.setWidth('85px');
		
		fontSize.setWidth('58px');
		while (b = btns.shift()) {
			tb.appendChild(b);
		}
		styleContainer.appendChild(tb);
		
		tb = new zul.wgt.Toolbar({sclass: 'zsstylepanel-toolbar'});
		btns = builder.addAll(['fontColor', 'backColor', 'border', 'verticalAlign', 'horizontalAlign','wrapText']).build();
		while (b = btns.shift()) {
			tb.appendChild(b);
		}
		styleContainer.appendChild(tb);
		this._styleContainer = styleContainer;
		
		this._menuContainer = new zul.wgt.Div({sclass: 'zsstylepanel-menu'});
		this.appendChild(this._menuContainer); // The 3rd child is menu container
	},
	getMenuContainer: function() {
		return this._menuContainer;
	},
	getStyleContainer: function() {
		return this._styleContainer;
	},
	setDisabled: function (actions) {
		for (var n = this.firstChild; n; n = n.nextSibling) {//toolbars
			for (var chd = n.firstChild;chd; chd = chd.nextSibling) {//buttons
				if (!chd.setDisabled) {
					continue;
				}
				chd.setDisabled(actions);
			}
		}
	},
	_closeStylePanel: function () {
		this.close({sendOnOpen:true});
		this._wgt.focus(true);
	},
	onFloatUp: function (ctl, opt) {
		if (!this.isVisible()) {
			return;
		}

		var origin = ctl.origin,
			sheet = this._wgt.sheetCtrl;

		if (sheet) {
			// ZSS-607: close panel when click outside style popup or menu popup
			if (zk.ie < 11 && origin == this) {
				this._closeStylePanel();
			}
			var menupopups = [sheet.getCellMenupopup(), sheet.getColumnHeaderMenupopup(), sheet.getRowHeaderMenupopup()];
			for (var i = menupopups.length - 1; i >= 0; i--) {
				if (triggerByMenupopup(menupopups[i], origin, zk.ie && opt && opt.triggerByFocus)) {
					return;
				}
			}
		}
		
		this.$supers(zss.StylePanel, 'onFloatUp', arguments);
	},
	getSclass: function () {
		return 'zsstylepanel';
	},
	// ZSS-383: turn off stack-up
	shallStackup_: function () {
		return false;
	}
});
	
zss.MenupopupFactory = zk.$extends(zk.Object, {
	$init: function (wgt) {
		this._wgt = wgt;
	},
	/**
	 * Returns a newly-created paste menupopup
	 */
	paste: function () {
		var wgt = this._wgt,
			p = new zss.Menupopup();
		
		p.appendChild(newActionMenuitem(wgt, 'paste'));
		p.appendChild(newActionMenuitem(wgt, 'pasteFormula'));
		p.appendChild(newActionMenuitem(wgt, 'pasteValue'));
		p.appendChild(newActionMenuitem(wgt, 'pasteAllExceptBorder'));
		p.appendChild(newActionMenuitem(wgt, 'pasteTranspose'));
		p.appendChild(newActionMenuitem(wgt, 'pasteSpecial'));
		return p;
	},
	/**
	 * Return a newly-created border menupopup
	 * @return zul.menu.Menupopup
	 */
	border: function () {
		var wgt = this._wgt,
			p = new zss.Menupopup(),
			colorMenu = newBorderColorMenu(wgt);
			
		if (colorMenu) {//for toolbarbutton to get color
			p.colorMenu = colorMenu;
		}

		p.appendChild(newBorderActionMenuitem(wgt, colorMenu, 'borderBottom', '/web/zss/img/border-bottom.png'));
		p.appendChild(newBorderActionMenuitem(wgt, colorMenu, 'borderTop', '/web/zss/img/border-top.png'));
		p.appendChild(newBorderActionMenuitem(wgt, colorMenu, 'borderLeft', '/web/zss/img/border-left.png'));
		p.appendChild(newBorderActionMenuitem(wgt, colorMenu, 'borderRight', '/web/zss/img/border-right.png'));
		p.appendChild(new zul.menu.Menuseparator());
		
		p.appendChild(newBorderActionMenuitem(wgt, colorMenu, 'borderNo', '/web/zss/img/border.png'));
		p.appendChild(newBorderActionMenuitem(wgt, colorMenu, 'borderAll', '/web/zss/img/border-all.png'));
		p.appendChild(newBorderActionMenuitem(wgt, colorMenu, 'borderOutside', '/web/zss/img/border-outside.png'));
		p.appendChild(newBorderActionMenuitem(wgt, colorMenu, 'borderInside', '/web/zss/img/border-inside.png'));
		p.appendChild(new zul.menu.Menuseparator());
		
		p.appendChild(newBorderActionMenuitem(wgt, colorMenu, 'borderInsideHorizontal', '/web/zss/img/border-horizontal.png'));
		p.appendChild(newBorderActionMenuitem(wgt, colorMenu, 'borderInsideVertical', '/web/zss/img/border-vertical.png'));
		
		if (colorMenu) {
			p.appendChild(new zul.menu.Menuseparator());
			p.appendChild(colorMenu);
		}
		return p;
	},
	verticalAlign: function () {
		var wgt = this._wgt,
			p = new zss.Menupopup();
		
		p.appendChild(newActionMenuitem(wgt, 'verticalAlignTop', null));
		p.appendChild(newActionMenuitem(wgt, 'verticalAlignMiddle', null));
		p.appendChild(newActionMenuitem(wgt, 'verticalAlignBottom', null));
		return p;
	},
	horizontalAlign: function () {
		var wgt = this._wgt,
			p = new zss.Menupopup();
		
		p.appendChild(newActionMenuitem(wgt, 'horizontalAlignLeft', null));
		p.appendChild(newActionMenuitem(wgt, 'horizontalAlignCenter', null));
		p.appendChild(newActionMenuitem(wgt, 'horizontalAlignRight', null));
		return p;
	},
	mergeAndCenter: function () {
		var wgt = this._wgt,
			p = new zss.Menupopup();
		
		p.appendChild(newActionMenuitem(wgt, 'mergeAndCenter'));
		p.appendChild(newActionMenuitem(wgt, 'mergeAcross'));
		p.appendChild(newActionMenuitem(wgt, 'mergeCell'));
		p.appendChild(newActionMenuitem(wgt, 'unmergeCell'));
		return p;
	},
	insert: function () {
		var wgt = this._wgt,
			p = new zss.Menupopup(),
			insertCellMenu = new zss.Menu({
				label: msgzss.action.insertCell,
				sclass: 'insertCell'
			}),
			insertCellMP = new zss.Menupopup();
		
		insertCellMP.appendChild(newActionMenuitem(wgt, 'shiftCellRight'));
		insertCellMP.appendChild(newActionMenuitem(wgt, 'shiftCellDown'));
		insertCellMenu.appendChild(insertCellMP);
		p.appendChild(insertCellMenu);
		
		p.appendChild(newActionMenuitem(wgt, 'insertSheetRow'));
		p.appendChild(newActionMenuitem(wgt, 'insertSheetColumn'));
		return p;
	},
	del: function () {
		var wgt = this._wgt,
			p = new zss.Menupopup(),
			deleteCellMenu = new zss.Menu({
				label: msgzss.action.deleteCell,
				sclass: 'deleteCell'
			}),
			deleteCellMP = new zss.Menupopup();
		deleteCellMP.appendChild(newActionMenuitem(wgt, 'shiftCellLeft'));
		deleteCellMP.appendChild(newActionMenuitem(wgt, 'shiftCellUp'));
		deleteCellMenu.appendChild(deleteCellMP);
		p.appendChild(deleteCellMenu);
		
		p.appendChild(newActionMenuitem(wgt, 'deleteSheetRow'));
		p.appendChild(newActionMenuitem(wgt, 'deleteSheetColumn'));
		return p;
	},
	//TODO
	format: function () {
		
	},
	autoSum: function () {
		var wgt = this._wgt,
			p = new zss.Menupopup();
		
		p.appendChild(newActionMenuitem(wgt, 'autoSum'));
		p.appendChild(newActionMenuitem(wgt, 'average'));
		p.appendChild(newActionMenuitem(wgt, 'countNumber'));
		p.appendChild(newActionMenuitem(wgt, 'max'));
		p.appendChild(newActionMenuitem(wgt, 'min'));
		p.appendChild(newActionMenuitem(wgt, 'moreFunction'));
		return p;
	},
	clear: function () {
		var wgt = this._wgt,
			p = new zss.Menupopup();
		
		p.appendChild(newActionMenuitem(wgt, 'clearContent'));
		p.appendChild(newActionMenuitem(wgt, 'clearStyle'));
		p.appendChild(newActionMenuitem(wgt, 'clearAll'));
		return p;
	},
	sortAndFilter: function () {
		var wgt = this._wgt,
			p = new zss.Menupopup();
		
		p.appendChild(newActionMenuitem(wgt, 'sortAscending'));
		p.appendChild(newActionMenuitem(wgt, 'sortDescending'));
		p.appendChild(newActionMenuitem(wgt, 'customSort'));
		p.appendChild(newActionMenuitem(wgt, 'filter'));
		p.appendChild(newActionMenuitem(wgt, 'clearFilter'));
		p.appendChild(newActionMenuitem(wgt, 'reapplyFilter'));
		return p;
	},
	insertChart: function () {
		var wgt = this._wgt,
			p = new zss.Menupopup(),
			columnChartMenu = new zss.Menu({
				label: msgzss.action.columnChart,
				sclass: 'columnChart'
			}),
			lineChartMenu = new zss.Menu({
				label: msgzss.action.lineChart,
				sclass: 'lineChart'
			}),
			pieChartMenu = new zss.Menu({
				label: msgzss.action.pieChart,
				sclass: 'pieChart'
			}),
			barChartMenu = new zss.Menu({
				label: msgzss.action.barChart,
				sclass: 'barChart'
			}),
			otherChartMenu = new zss.Menu({
				label: msgzss.action.otherChart,
				sclass: 'otherChart'
			}),
			columnChartMP = new zss.Menupopup(),
			lineChartMP = new zss.Menupopup(),
			pieChartMP = new zss.Menupopup(),
			barChartMP = new zss.Menupopup(),
			otherChartMP = new zss.Menupopup();

		columnChartMP.appendChild(newActionMenuitem(wgt, 'columnChart'));
		columnChartMP.appendChild(newActionMenuitem(wgt, 'columnChart3D'));
		columnChartMenu.appendChild(columnChartMP);
		p.appendChild(columnChartMenu);

		lineChartMP.appendChild(newActionMenuitem(wgt, 'lineChart'));
		lineChartMP.appendChild(newActionMenuitem(wgt, 'lineChart3D'));
		lineChartMenu.appendChild(lineChartMP);
		p.appendChild(lineChartMenu);

		pieChartMP.appendChild(newActionMenuitem(wgt, 'pieChart'));
		pieChartMP.appendChild(newActionMenuitem(wgt, 'pieChart3D'));
		pieChartMenu.appendChild(pieChartMP);
		p.appendChild(pieChartMenu);

		barChartMP.appendChild(newActionMenuitem(wgt, 'barChart'));
		barChartMP.appendChild(newActionMenuitem(wgt, 'barChart3D'));
		barChartMenu.appendChild(barChartMP);
		p.appendChild(barChartMenu);

		p.appendChild(newActionMenuitem(wgt, 'areaChart'));
		p.appendChild(newActionMenuitem(wgt, 'scatterChart'));

		otherChartMP.appendChild(newActionMenuitem(wgt, 'doughnutChart'));
		otherChartMenu.appendChild(otherChartMP);
		p.appendChild(otherChartMenu);
		return p;
	},
	columnChart: function () {
		var wgt = this._wgt,
			p = new zss.Menupopup();
		
		p.appendChild(newActionMenuitem(wgt, 'columnChart'));
		p.appendChild(newActionMenuitem(wgt, 'columnChart3D'));
		return p;
	},
	lineChart: function () {
		var wgt = this._wgt,
			p = new zss.Menupopup();
		
		p.appendChild(newActionMenuitem(wgt, 'lineChart'));
		p.appendChild(newActionMenuitem(wgt, 'lineChart3D'));
		return p;
	},
	pieChart: function () {
		var wgt = this._wgt,
			p = new zss.Menupopup();
		
		p.appendChild(newActionMenuitem(wgt, 'pieChart'));
		p.appendChild(newActionMenuitem(wgt, 'pieChart3D'));
		return p;
	},
	barChart: function () {
		var wgt = this._wgt,
			p = new zss.Menupopup();
		
		p.appendChild(newActionMenuitem(wgt, 'barChart'));
		p.appendChild(newActionMenuitem(wgt, 'barChart3D'));
		return p;
	},
	otherChart: function () {
		var wgt = this._wgt,
			p = new zss.Menupopup();		
		p.appendChild(newActionMenuitem(wgt, 'doughnutChart'));
		return p;
	},
	rowHeader: function () {
		var wgt = this._wgt,
			p = new zss.Menupopup(wgt);
		p.appendChild(newActionMenuitem(wgt, 'cut'));
		p.appendChild(newActionMenuitem(wgt, 'copy'));
		p.appendChild(newActionMenuitem(wgt, 'paste'));
		p.appendChild(newActionMenuitem(wgt, 'pasteSpecial'));
		p.appendChild(new zul.menu.Menuseparator());
		
		p.appendChild(newActionMenuitem(wgt, 'insertSheetRow'));
		p.appendChild(newActionMenuitem(wgt, 'deleteSheetRow'));
		p.appendChild(newActionMenuitem(wgt, 'clearContent'));
		p.appendChild(new zul.menu.Menuseparator());
		
		p.appendChild(newActionMenuitem(wgt, 'formatCell'));
		p.appendChild(newActionMenuitem(wgt, 'dataValidation'));
		p.appendChild(newActionMenuitem(wgt, 'rowHeight'));
		p.appendChild(newActionMenuitem(wgt, 'hideRow'));
		p.appendChild(newActionMenuitem(wgt, 'unhideRow'));
		
		return p;
	},
	columnHeader: function () {
		var wgt = this._wgt,
			p = new zss.Menupopup(wgt);
		p.appendChild(newActionMenuitem(wgt, 'cut'));
		p.appendChild(newActionMenuitem(wgt, 'copy'));
		p.appendChild(newActionMenuitem(wgt, 'paste'));
		p.appendChild(newActionMenuitem(wgt, 'pasteSpecial'));
		p.appendChild(new zul.menu.Menuseparator());
		
		p.appendChild(newActionMenuitem(wgt, 'insertSheetColumn'));
		p.appendChild(newActionMenuitem(wgt, 'deleteSheetColumn'));
		p.appendChild(newActionMenuitem(wgt, 'clearContent'));
		p.appendChild(new zul.menu.Menuseparator());
		
		p.appendChild(newActionMenuitem(wgt, 'formatCell'));
		p.appendChild(newActionMenuitem(wgt, 'dataValidation'));
		p.appendChild(newActionMenuitem(wgt, 'columnWidth'));
		p.appendChild(newActionMenuitem(wgt, 'hideColumn'));
		p.appendChild(newActionMenuitem(wgt, 'unhideColumn'));
		
		return p;
	},
	cell: function () {
		var wgt = this._wgt,
			p = new zss.StateMenupopup(wgt),
			insertMenu = new zss.Menu({
				label: msgzss.action.insert,
				sclass: 'insert'
			}),
			insertMP = new zss.Menupopup(),
			deleteMenu = new zss.Menu({
				label: msgzss.action.del,
				sclass: 'del'
			}),
			deleteMP = new zss.Menupopup(),
			filterMenu = new zss.Menu({
				label: msgzss.action.filter,
				sclass: 'filter'
			}),
			filterMP = new zss.Menupopup(),
			sortMenu = new zss.Menu({
				label: msgzss.action.sort,
				sclass: 'sort'
			}),
			sortMP = new zss.Menupopup();
		p.appendChild(newActionMenuitem(wgt, 'cut'));
		p.appendChild(newActionMenuitem(wgt, 'copy'));
		p.appendChild(newActionMenuitem(wgt, 'paste'));
		p.appendChild(newActionMenuitem(wgt, 'pasteSpecial'));
		p.appendChild(new zul.menu.Menuseparator());
		
		insertMP.appendChild(newActionMenuitem(wgt, 'shiftCellRight'));
		insertMP.appendChild(newActionMenuitem(wgt, 'shiftCellDown'));
		insertMP.appendChild(newActionMenuitem(wgt, 'insertSheetRow'));
		insertMP.appendChild(newActionMenuitem(wgt, 'insertSheetColumn'));
		insertMenu.appendChild(insertMP);
		p.appendChild(insertMenu);
		
		deleteMP.appendChild(newActionMenuitem(wgt, 'shiftCellLeft'));
		deleteMP.appendChild(newActionMenuitem(wgt, 'shiftCellUp'));
		deleteMP.appendChild(newActionMenuitem(wgt, 'deleteSheetRow'));
		deleteMP.appendChild(newActionMenuitem(wgt, 'deleteSheetColumn'));
		deleteMenu.appendChild(deleteMP);
		p.appendChild(deleteMenu);
		
		p.appendChild(newActionMenuitem(wgt, 'clearContent'));
		p.appendChild(new zul.menu.Menuseparator());
		
		filterMP.appendChild(newActionMenuitem(wgt, 'reapplyFilter'));
		filterMP.appendChild(newActionMenuitem(wgt, 'filter'));
		filterMenu.appendChild(filterMP);
		p.appendChild(filterMenu);
		
		sortMP.appendChild(newActionMenuitem(wgt, 'sortAscending'));
		sortMP.appendChild(newActionMenuitem(wgt, 'sortDescending'));
		sortMP.appendChild(newActionMenuitem(wgt, 'customSort'));
		sortMenu.appendChild(sortMP);
		p.appendChild(sortMenu);
		p.appendChild(new zul.menu.Menuseparator());

		function getCellByXY(info) {
			var pageX = info.pageX,
				pageY = info.pageY,
				sheet = info.sheet,
				position = zss.SSheetCtrl._calCellPos(sheet, pageX, pageY);
			return sheet.getCell(position[0], position[1]);
		}
		p.appendChild(newActionStateMenuitem(wgt, 'insertComment', null, 
			function(info){
				this.setVisible(!getCellByXY(info).comment)}));
		p.appendChild(newActionStateMenuitem(wgt, 'editComment', null, 
			function(info){
				this.setVisible(getCellByXY(info).comment)}));
		p.appendChild(newActionStateMenuitem(wgt, 'deleteComment', null, 
			function(info){
				this.setVisible(getCellByXY(info).comment)}));
		p.appendChild(new zul.menu.Menuseparator());
		
		p.appendChild(newActionMenuitem(wgt, 'formatCell'));
		p.appendChild(newActionMenuitem(wgt, 'dataValidation'));
		p.appendChild(newActionMenuitem(wgt, 'hyperlink'));
		p.appendChild(newActionMenuitem(wgt, 'richTextEdit'));
		return p;
	},
	style: function () {
		return new zss.StylePanel(this._wgt);
	}
});

zss.Buttons = zk.$extends(zk.Object, {
}, {//static
	HOME_DEFAULT: ['newBook', 'saveBook', 'exportPDF', 'separator', 
	          'paste', 'cut', 'copy', 'separator',
	          'fontFamily', 'fontSize', 'fontBold', 'fontItalic', 'fontUnderline', 
	          'fontStrike', 'border', 'fontColor', 'backColor', 'separator',
	          'verticalAlign', 'horizontalAlign', 'textIndentDecrease', 'textIndentIncrease', 
	          'wrapText', 'mergeAndCenter', 'separator', 'insert', 'del', 'format', 'separator',
	          'autoSum', 'clear', 'sortAndFilter', 'separator',
	          'protectSheet', 'gridlines', 'separator',
	          'insertPicture', 'insertChart', 'hyperlink'
	          ],
	 INSERT_DEFAULT: ['insertPicture', 'separator',
	                  'columnChart', 'lineChart', 'pieChart', 
	                  'barChart', 'areaChart', 'scatterChart', 
	                  'otherChart', 'separator',
	                  'hyperlink'],
	 FORMULA_DEFAULT: ['insertFunction', 'autoSum', 'financial', 
	                   'logical', 'text', 'dateAndTime', 
	                   'lookupAndReference', 'mathAndTrig', 'moreFunction']
});

zss.TooltipPopup = zk.$extends(zul.wgt.Popup, {
	open: function (ref, offset, position, opts) {
		this.$supers(zss.TooltipPopup, 'open', [ref, offset, 'after_center', opts]);
	},
	getSclass: function () {
		return 'zsttpp';
	}
});
	function newActionToolbarbutton(wgt, action, image, data, labelOnly, icon) {
		data = data || {};
		var label = data.label == null ? msgzss.action[action] : data.label;
		var tooltip = data.tooltip || label;
		var pptt = new zss.TooltipPopup({id: action + '-tooltip'});
		pptt.appendChild(new zul.wgt.Label({value: tooltip}));
		return [new zss.Toolbarbutton({
			$action: action,
			label: labelOnly ? label : null,
			iconSclass: data.iconSclass || (icon ? icon : null),
			image: data.iconURI || (image ? zk.ajaxURI(image, {au: true}) : null),
			tooltip: action + '-tooltip, delay=0',
			onClick: function () {
				var sheet = wgt.sheetCtrl;
				if (sheet) {
					var s = sheet.getLastSelection(),
						tRow = s.top,
						lCol = s.left,
						bRow = s.bottom,
						rCol = s.right,
						selType = sheet.selType ? sheet.selType : zss.SEL.CELL; //ZSS-717

					sheet.triggerSelection(tRow, lCol, bRow, rCol);
					wgt.fireToolbarAction(action, {tRow: tRow, lCol: lCol, bRow: bRow, rCol: rCol, type: selType}); //ZSS-717
				} else {
					wgt.fireToolbarAction(action, {tRow: -1, lCol: -1, bRow: -1, rCol: -1, type: zss.SEL.ALL});  //ZSS-717
				}
			}
		}, wgt), pptt];
	}
	
	/**
	 * return ColorPicker's construction function upon user configurations under PE
	 */
	function getColorButtonConstructor(spreadsheet){
		return (!!zss.ColorbuttonEx && spreadsheet.getColorPickerExUsed()) ? zss.ColorbuttonEx : zss.Colorbutton;
	}
	
zss.ButtonBuilder = zk.$extends(zk.Object, {
	/**
	 * @param zss.Spreadsheet
	 */
	$init: function (wgt, popupHolder) {
		this._wgt = wgt;
		this._popupHodler = popupHolder;
		this.contents = [];
		
		//ZSS-1171
		this.isStylePanel = popupHolder.$instanceof(zss.StylePanel);
		this.isToolbar = popupHolder.$instanceof(zss.ResizeableToolbar);
	},
	applyHolder: function (popup) {
		if(this._popupHodler) {
			this._popupHodler.appendChild(popup);
		}
		return popup;
	},
	/**
	 * @param String
	 */
	add: function (element) {
		this.contents.push(element);
		return this;
	},
	/**
	 * @param String array
	 */
	addAll: function (elements) {
		var cts = this.contents;
		for (var i = 0, len = elements.length; i < len; i++) {
			cts.push(elements[i]);
		}
		return this;
	},
	/**
	 * Returns a newly-created buttons
	 */
	build: function () {
		var btns = [],
			cts = this.contents;
		while (fn = cts.shift()) {
			var btn = (this[fn.key || fn] || this.$custom).apply(this, [fn]);
			if (btn instanceof Array && btn.length > 1) {
				btns.push(btn[0]);
				btns.push(btn[1]);
			} else {
				btns.push(btn);
			}
		}
		return btns;
	},
	$custom: function (data) {
		data = data || {};

		if (data.templateURI) {
		 	var container = new zul.wgt.Span({sclass: 'zstbtn zstbtn-' + data.key});
		 	var spreadsheet = this._wgt;
			getScript(data.templateURI, function (script) {
				var func = jq.evalJSON(script);
				var isBound = false,
					init;
				container.listen({onBind: init = function () {
						if (isBound) return;
						isBound = true;
						func.apply(container, [spreadsheet, data]);
					}, onUnbind: function () {
						isBound = false;
					}
				});
				if (container.desktop) {
					init();
				}
			});
			return container;
		} else {
			return newActionToolbarbutton(this._wgt, data.key, data.iconURI, data);
		}
	},
	/**
	 * @return zss.ToolbarbuttonSeparator
	 */
	separator: function (data) {
		return new zss.ToolbarbuttonSeparator({
			$action: 'separator'
		});
	},
	/**
	 * Create new book button
	 * @return zss.Toolbarbutton
	 */
	newBook: function (data) {
		return newActionToolbarbutton(this._wgt, 'newBook', null, data);
	},
	/**
	 * Create save book button 
	 * @return zss.Toolbarbutton
	 */
	saveBook: function (data) {
		return newActionToolbarbutton(this._wgt, 'saveBook', null, data);
	},
	/**
	 * Create export PDF button
	 * @return zss.Toolbarbutton
	 */
	exportPDF: function (data) {
		return newActionToolbarbutton(this._wgt, 'exportPDF', null, data);
	},
	paste: function (data) {
		var wgt = this._wgt;
		var btn = newActionToolbarbutton(wgt, 'paste', null, data),
			b = btn[0];
		b.setPopup(this.applyHolder(new zss.MenupopupFactory(wgt).paste()));
		return b;
	},
	cut: function (data) {
		return newActionToolbarbutton(this._wgt, 'cut', null, data);
	},
	copy: function (data) {
		return newActionToolbarbutton(this._wgt, 'copy', null, data);
	},
	fontFamily: function (data) {
		return new zss.FontFamilyCombobox({
			$action: 'fontFamily',
			width: '115px'
		}, this._wgt, this); //ZSS-1171
	},
	fontSize: function (data) {
		return new zss.FontSizeCombobox({
			$action: 'fontSize',
			width: '55px'
		}, this._wgt, this); //ZSS-1171
	},
	//ZSS-1171: no toolbar or no context menu
	_skipNoShow: function () {
		return (this.isStylePanel && !this._wgt.getShowContextMenu())
		|| (this.isToolbar && !this._wgt.getShowToolbar());
	},
	//ZSS-1171: no need to precess the event
	_skipEvent: function (evt, b) {
		if (this._skipNoShow()) {
			return true;
		}
		if (evt.name == "onCellSelection") {
			var d = evt.data;
			// same cell, skip
			if (d.top == b.preRow && d.left == b.preCol) {
				return true;
			}
			b.preRow = d.top;
			b.preCol = d.left;
			return false;
		} else if (evt.name == "onCellUpdate") {
			var d = evt.data;
			// not on the selected cell, skip
			return (d.top != b.preRow || d.left != b.preCol);
		}
		// not the event concerned, skip
		return true;
	},
	fontBold: function (data) {
		var wgt = this._wgt,
			btn = newActionToolbarbutton(wgt, 'fontBold', null, data),
			b = btn[0],
			bd = this, //ZSS-1171
			fn = function (evt) {
				//ZSS-1171
				if (bd._skipEvent(evt, b)) {
					return;
				}
				var sheet = wgt.sheetCtrl;
				if (sheet) {
					var d = evt.data,
						c = sheet.getCell(d.top, d.left);
					if (c) {
						b.setSelectedEffect(c.isFontBold());
					}
				}
			};
		
		b.listen({onBind: function () {
			var sheet = wgt.sheetCtrl;
			if (sheet) {
				sheet.listen({onCellSelection: fn, onCellUpdate: fn});
			}
		}});
		b.listen({onClick: function () {
			if (!b.isDisabled()) {
				b.setSelectedEffect(true);
			}
		}});
		
		return btn;
	},
	fontItalic: function (data) {
		var wgt = this._wgt,
			btn = newActionToolbarbutton(this._wgt, 'fontItalic', null, data),
			b = btn[0],
			bd = this, //ZSS-1171
			fn = function (evt) {
				//ZSS-1171
				if (bd._skipEvent(evt, b)) {
					return;
				}
				var sheet = wgt.sheetCtrl;
				if (sheet) {
					var d = evt.data,
						c = sheet.getCell(d.top, d.left);
					if (c) {
						b.setSelectedEffect(c.isFontItalic());
					}	
				}
			};
		
		b.listen({onBind: function () {
			var sheet = wgt.sheetCtrl;
			if (sheet) {
				sheet.listen({onCellSelection: fn, onCellUpdate: fn});
			}
		}});
		b.listen({onClick: function () {
			if (!b.isDisabled()) {
				b.setSelectedEffect(true);
			}
		}});
		
		return btn;
	},
	fontUnderline: function (data) {
		var wgt = this._wgt,
			btn = newActionToolbarbutton(this._wgt, 'fontUnderline', null, data),
			b = btn[0],
			bd = this, //ZSS-1171
			fn = function (evt) {
				//ZSS-1171
				if (bd._skipEvent(evt, b)) {
					return;
				}
				var sheet = wgt.sheetCtrl;
				if (sheet) {
					var d = evt.data,
						c = sheet.getCell(d.top, d.left);
					if (c) {
						b.setSelectedEffect(c.isFontUnderline());
					}
				}
			};
		
		b.listen({onBind: function () {
			var sheet = wgt.sheetCtrl;
			if (sheet) {
				sheet.listen({onCellSelection: fn, onCellUpdate: fn});
			}
		}});
		b.listen({onClick: function () {
			if (!b.isDisabled()) {
				b.setSelectedEffect(true);
			}
		}});
		return btn;
	},
	fontStrike: function (data) {
		var wgt = this._wgt,
			btn = newActionToolbarbutton(this._wgt, 'fontStrike', null, data),
			b = btn[0],
			bd = this, //ZSS-1171
			fn = function (evt) {
				//ZSS-1171
				if (bd._skipEvent(evt, b)) {
					return;
				}
				var sheet = wgt.sheetCtrl;
				if (sheet) {
					var d = evt.data,
						c = sheet.getCell(d.top, d.left);
					if (c) {
						b.setSelectedEffect(c.isFontStrikeout());
					}
				}
			};
		
		b.listen({onBind: function () {
			var sheet = wgt.sheetCtrl;
			if (sheet) {
				sheet.listen({onCellSelection: fn, onCellUpdate: fn});
			}
		}});
		b.listen({onClick: function () {
			if (!b.isDisabled()) {
				b.setSelectedEffect(true);
			}
		}});
		return btn;
	},
	border: function (data) {
		data = data || {};
		var wgt = this._wgt,
			pp = this.applyHolder(new zss.MenupopupFactory(wgt).border()),
			b = new zss.Toolbarbutton({
				$action: 'border',
				tooltip: 'border-tooltip, delay=0',
				image: data.iconURI,
				onClick: function () {
					var sht = wgt.sheetCtrl;
					if (sht) {
						var s = sht.getLastSelection(),
							color = pp.colorMenu ? pp.colorMenu.getColor() : '',
							selType = sht.selType ? sht.selType : zss.SEL.CELL; //ZSS-717
							
						wgt.fireToolbarAction('border', {color: color, tRow: s.top, lCol: s.left, bRow: s.bottom, rCol: s.right, type: selType});  //ZSS-717	
					}
				}
			}, wgt);
		b.setPopup(pp);
		var pptt = new zss.TooltipPopup({id: 'border-tooltip'});
		pptt.appendChild(new zul.wgt.Label({value: data.tooltip || msgzss.action['border']}));
		return [b, pptt];
	},
	backColor: function (data) {
		var wgt = this._wgt;
		var colorButtonConstructor = getColorButtonConstructor(wgt);
		var pptt = new zss.TooltipPopup({id: 'backColor-tooltip'});
		pptt.appendChild(new zul.wgt.Label({value: data.tooltip || msgzss.action['backColor']}));
		return [new colorButtonConstructor({
			$action: 'backColor',
			color: '#FFFFFF',
			image: data.iconURI,
			tooltip: 'backColor-tooltip, delay=0',
			onClick: function () {
				var sht = wgt.sheetCtrl;
				if (sht) {
					var s = sht.getLastSelection(),
						selType = sht.selType ? sht.selType : zss.SEL.CELL; //ZSS-717

					wgt.fireToolbarAction('backColor', {color: this.getColor(), tRow: s.top, lCol: s.left, bRow: s.bottom, rCol: s.right, type: selType}); //ZSS-717	
				}
			}
		}, wgt, this._popupHodler), pptt];
	},
	fontColor: function (data) {
		data = data || {};
		var wgt = this._wgt;
		var colorButtonConstructor = getColorButtonConstructor(wgt);
		var pptt = new zss.TooltipPopup({id: 'fontColor-tooltip'});
        pptt.appendChild(new zul.wgt.Label({value: data.tooltip || msgzss.action['fontColor']}));
        return [new colorButtonConstructor({
			$action: 'fontColor',
			color: data.color || '#000000',
			tooltip: 'fontColor-tooltip, delay=0',
			image: data.iconURI,
			onClick: function () {
				var sht = wgt.sheetCtrl;
				if (sht) {
					var s = sht.getLastSelection(),
						selType = sht.selType ? sht.selType : zss.SEL.CELL; //ZSS-717

					wgt.fireToolbarAction('fontColor', {color: this.getColor(), tRow: s.top, lCol: s.left, bRow: s.bottom, rCol: s.right, type: selType}); //ZSS-717
				}
			}
		}, wgt, this._popupHodler), pptt];
	},
	verticalAlign: function (data) {
		var wgt = this._wgt,
			btn = newActionToolbarbutton(wgt, 'verticalAlign', null, data),
			b = btn[0],
			p = this.applyHolder(new zss.MenupopupFactory(wgt).verticalAlign()),
			item = p.firstChild,
			bd = this, //ZSS-1171
			fn = function (evt) {
				//ZSS-1171
				if (bd._skipEvent(evt, b)) {
					return;
				}
				var sheet = wgt.sheetCtrl;
				if (sheet) {
					var d = evt.data,
						c = sheet.getCell(d.top, d.left);
					if (c) {
						var a = c.getVerticalAlign(),
							item = p.firstChild;
						for (; item; item = item.nextSibling) {
							if (item.$getAction() == a) { //ZSS-1276
								b.setSelectedEffect(true, item, true);
								break;
							}
						}
					}	
				}
			};
		
		b.listen({onBind: function () {
			var sheet = wgt.sheetCtrl;
			if (sheet) {
				sheet.listen({onCellSelection: fn, onCellUpdate: fn});
			}
		}});
		for (;item; item = item.nextSibling) {
			item.listen({onClick: function () {
				if (!b.isDisabled()) {
					b.setSelectedEffect(true, item);
				}
			}});
		}
		
		b.setClickDisabled(true);
		b.setPopup(p);
		return btn;
	},
	horizontalAlign: function (data) {
		var wgt = this._wgt,
			btn = newActionToolbarbutton(wgt, 'horizontalAlign', null, data),
			b = btn[0],
			p = this.applyHolder(new zss.MenupopupFactory(wgt).horizontalAlign()),
			item = p.firstChild,
			bd = this, //ZSS-1171
			fn = function (evt) {
				//ZSS-1171
				if (bd._skipEvent(evt, b)) {
					return;
				}
				var sheet = wgt.sheetCtrl;
				if (sheet) {
					var d = evt.data,
						c = sheet.getCell(d.top, d.left);
					if (c) {
						var a = c.getHorizontalAlign(),
							item = p.firstChild;
						for (; item; item = item.nextSibling) {
							if (item.$getAction() == a) { // ZSS-1276
								b.setSelectedEffect(true, item, true);
								break;
							}
						}
					}	
				}
			};
		
		b.listen({onBind: function () {
			var sheet = wgt.sheetCtrl;
			if (sheet) {
				sheet.listen({onCellSelection: fn, onCellUpdate: fn});
			}
		}});
		for (;item; item = item.nextSibling) {
			item.listen({onClick: function () {
				if (!b.isDisabled()) {
					b.setSelectedEffect(true, item);
				}
			}});
		}
		
		b.setClickDisabled(true);
		b.setPopup(p);
		return btn;
	},
	textIndentIncrease: function (data) {
		return newActionToolbarbutton(this._wgt, 'textIndentIncrease', null, data);
	},
	textIndentDecrease: function (data) {
		return newActionToolbarbutton(this._wgt, 'textIndentDecrease', null, data);
	},
	wrapText: function (data) {
		var wgt = this._wgt,
			btn = newActionToolbarbutton(wgt, 'wrapText', null, data),
			b = btn[0],
			bd = this, //ZSS-1171
			fn = function (evt) {
				//ZSS-1171
				if (bd._skipEvent(evt, b)) {
					return;
				}
				var sheet = wgt.sheetCtrl;
				if (sheet) {
					var d = evt.data,
						c = sheet.getCell(d.top, d.left);
					if (c) {
						b.setSelectedEffect(c.wrap);
					}	
				}
			};
		b.listen({onBind: function () {
			var sheet = wgt.sheetCtrl;
			if (sheet) {
				sheet.listen({onCellSelection: fn, onCellUpdate: fn});
			}
		}});
		return btn;
	},
	mergeAndCenter: function (data) {
		var wgt = this._wgt,
			btn = newActionToolbarbutton(wgt, 'mergeAndCenter', null, data),
			b = btn[0];
		b.setPopup(this.applyHolder(new zss.MenupopupFactory(wgt).mergeAndCenter()));
		return btn;
	},
	insert: function (data) {
		var wgt = this._wgt,
			btn = newActionToolbarbutton(wgt, 'insert', null, data),
			b = btn[0];
		b.setPopup(this.applyHolder(new zss.MenupopupFactory(wgt).insert()));
		b.setClickDisabled(true);
		return btn;
	},
	del: function (data) {
		var wgt = this._wgt,
			btn = newActionToolbarbutton(wgt, 'del', null, data),
			b = btn[0];
		b.setPopup(this.applyHolder(new zss.MenupopupFactory(wgt).del()));
		b.setClickDisabled(true);
		return btn;
	},
	format: function (data) {
		//TODO: format
	},
	insertPicture: function (data) {
		return newActionToolbarbutton(this._wgt, 'insertPicture', null, data);
	},
	insertChart: function (data) {
		var wgt = this._wgt,
			btn = newActionToolbarbutton(wgt, 'insertChart', null, data),
			b = btn[0];
		b.setPopup(this.applyHolder(new zss.MenupopupFactory(wgt).insertChart()));
		return btn;
	},
	columnChart: function (data) {
		var wgt = this._wgt,
			btn = newActionToolbarbutton(wgt, 'columnChart', null, data, true),
			b = btn[0];
		b.setClickDisabled(true);
		b.setPopup(this.applyHolder(new zss.MenupopupFactory(wgt).columnChart()));
		return btn;
	},
	lineChart: function (data) {
		var wgt = this._wgt,
			btn = newActionToolbarbutton(wgt, 'lineChart', null, data, true),
			b = btn[0];
		b.setClickDisabled(true);
		b.setPopup(this.applyHolder(new zss.MenupopupFactory(wgt).lineChart()));
		return btn;
	},
	pieChart: function (data) {
		var wgt = this._wgt,
			btn = newActionToolbarbutton(wgt, 'pieChart', null, data, true),
			b = btn[0];
		b.setClickDisabled(true);
		b.setPopup(this.applyHolder(new zss.MenupopupFactory(wgt).pieChart()));
		return btn;
	},
	barChart: function (data) {
		var wgt = this._wgt,
			btn = newActionToolbarbutton(wgt, 'barChart', null, data, true),
			b = btn[0];
		b.setClickDisabled(true);
		b.setPopup(this.applyHolder(new zss.MenupopupFactory(wgt).barChart()));
		return btn;
	},
	areaChart: function (data) {
		var b = newActionToolbarbutton(this._wgt, 'areaChart', null, data, true);
		return b;
	},
	scatterChart: function (data) {
		return newActionToolbarbutton(this._wgt, 'scatterChart', null, data, true);
	},
	otherChart: function (data) {
		var wgt = this._wgt,
			btn = newActionToolbarbutton(wgt, 'otherChart', null, data, true),
			b = btn[0];
		b.setClickDisabled(true);
		b.setPopup(this.applyHolder(new zss.MenupopupFactory(wgt).otherChart()));
		return btn;
	},
	hyperlink: function (data) {
		return newActionToolbarbutton(this._wgt, 'hyperlink', null, data);
	},
	clear: function (data) {
		var wgt = this._wgt,
			btn = newActionToolbarbutton(wgt, 'clear', null, data),
			b = btn[0];
		b.setClickDisabled(true);
		b.setPopup(this.applyHolder(new zss.MenupopupFactory(wgt).clear()));
		return btn;
	},
	sortAndFilter: function (data) {
		var wgt = this._wgt,
			btn = newActionToolbarbutton(wgt, 'sortAndFilter', null, data),
			b = btn[0];
		b.setPopup(this.applyHolder(new zss.MenupopupFactory(wgt).sortAndFilter()));
		b.setClickDisabled(true);
		return btn;
	},
	autoSum: function () {
		//TODO:
//		var wgt = this._wgt,
//			b = new zss.Toolbarbutton({
//				$action: 'autoSum',
//				tooltiptext: msgzss.action.autoSum,
//				image: data.iconURI || zk.ajaxURI('/web/zss/img/sum.png', AU)
//			}, wgt);
//		b.setPopup(new zss.MenupopupFactory(wgt).autoSum());
//		return b;
	},
	insertFunction: function (data) {
		return newActionToolbarbutton(this._wgt, 'insertFunction', null, data, true);
	},
	financial: function data() {
		return newActionToolbarbutton(this._wgt, 'financial', null, data, true);
	},
	logical: function (data) {
		return newActionToolbarbutton(this._wgt, 'logical', null, data, true);
	},
	text: function (data) {
		return newActionToolbarbutton(this._wgt, 'text', null, data, true);
	},
	dateAndTime: function (data) {
		return newActionToolbarbutton(this._wgt, 'dateAndTime', null, data, true);
	},
	lookupAndReference: function (data) {
		return newActionToolbarbutton(this._wgt, 'lookupAndReference', null, data, true);
	},
	mathAndTrig: function (data) {
		return newActionToolbarbutton(this._wgt, 'mathAndTrig', null, data, true);
	},
	moreFunction: function (data) {
		return newActionToolbarbutton(this._wgt, 'moreFunction', null, data, true);
	},
	protectSheet: function (data) {
		data = data || {};
		var wgt = this._wgt,
			b = new zss.ProtectSheetCheckbutton({
				$action: 'protectSheet', // ZSS-1269
				checked: wgt.isProtect(),
				image: data.iconURI,
				tooltip: 'protectSheet-tooltip, delay=0',
				onClick: function () {
					wgt.fireToolbarAction('protectSheet');
				}
			}, wgt);
		var pptt = new zss.TooltipPopup({id: 'protectSheet-tooltip'});
		pptt.appendChild(new zul.wgt.Label({value: data.tooltip || msgzss.action['protectSheet']}));
		return [b, pptt];
	},
	gridlines: function (data) {
		data = data || {};
		var wgt = this._wgt,
			b = new zss.DisplayGridlinesCheckbutton({
			$action: 'gridlines', //ZSS-1269
			checked: wgt.isDisplayGridlines(),
			image: data.iconURI,
			tooltip: 'gridlines-tooltip, delay=0',
			onClick: function () {
				wgt.fireToolbarAction('gridlines');
			}
		}, wgt);
		var pptt = new zss.TooltipPopup({id: 'gridlines-tooltip'});
		pptt.appendChild(new zul.wgt.Label({value: data.tooltip || msgzss.action['gridlines']}));
		return [b, pptt];
	}
})
})();
